/*******************************************************************************
 * Copyright (c) 2015-2018 Skymind, Inc.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Apache License, Version 2.0 which is available at
 * https://www.apache.org/licenses/LICENSE-2.0.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 ******************************************************************************/

package org.deeplearning4j.models.glove.count;

import org.deeplearning4j.models.sequencevectors.sequence.SequenceElement;

/**
 * Created by fartovii on 25.12.15.
 */
public interface CoOccurrenceWriter<T extends SequenceElement> {

    /**
     * This method implementations should write out objects immediately
     * @param object
     */
    void writeObject(CoOccurrenceWeight<T> object);

    /**
     * This method implementations should queue objects for writing out.
     *
     * @param object
     */
    void queueObject(CoOccurrenceWeight<T> object);

    /**
     * Implementations of this method should close everything they use, before eradication
     */
    void finish();
}
